package body load_instructions is

    use work.memory.all;

    procedure perform_memory_instruction ( instr : load_instruction ) is
        variable MDR : integer;
    begin
        MDR := read_memory ( effective_address_of ( instr ) );
        --  ...
    end procedure perform_memory_instruction;


    procedure disassemble ( instr : load_instruction;  L : inout line ) is
    begin
        disassemble ( instruction(instr), L );	-- disassemble opcode
        write ( L, ' ' );
        disassemble_reg ( instr.destination, L );
        write ( L, string'(", ") );
        write ( L, integer'image(instr.offset) );
        write ( L, '(' );
        disassemble_reg ( instr.base, L );
        write ( L, ')' );
    end procedure disassemble;
    

end package body load_instructions;
