package memory_instructions is

    use std.textio.all;
    use work.instructions.all;

    type memory_instruction is
        abstract new instruction with record
            base : register_number;
	    offset : integer;
        end record memory_instruction;
    
    function effective_address_of ( instr : memory_instruction )
        return integer;
    
    procedure perform_memory_instruction
        ( instr : memory_instruction ) is abstract;

end package memory_instructions;
